using FluentValidation;
using CMSMicroservice.Protobuf.Protos.UserAddress;
namespace CMSMicroservice.Protobuf.Validator.UserAddress;

public class SetAddressAsDefaultRequestValidator : AbstractValidator<SetAddressAsDefaultRequest>
{
    public SetAddressAsDefaultRequestValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<SetAddressAsDefaultRequest>.CreateWithOptions((SetAddressAsDefaultRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
